# converters.tcl

# 0 => 199306, 1 => 199311, 2 => 199406, 3 => 199411 ...
proc no2ed { no } {
   return [expr int(100*(1993+floor($no / 2)) + ($no % 2 ? 11 : 6))]
}

# 0 => 15.06.1993, 1 => 15.11.1993, 2 => 15.06.1994, 3 => 15.11.1994 ...
proc no2edExcel { no } {
   set y [expr int(1993+floor($no / 2))]
   if {$no % 2 == 1} {
      return "15.11.$y"
   }
   return "15.06.$y"
}

# 0 => 06/93, 1 => 11/93, 2 => 06/94, 3 => 11/94 ...
proc no2edShort { no } {
   set y [expr (int(1993+floor($no / 2))) % 100]
   if {$y<10} {set m "0$y"} else {set m "$y"} 
   if {$no % 2} { return "11/$m" } else { return "06/$m" }  
}

# 199306 => 0, 199311 => 1, 199406 => 2, 199411 => 3 ...
proc ed2no { ed } {
   return [expr int(2*(floor($ed/100)-1993) + ($ed % 100 - 6 ? 1 : 0))]
}

#  i <- 1..500  RGB 
proc i2color { i } {
   foreach {i1 r1 g1 b1} {1 200 0 0} {}
   set cs {
      10   200   0 200
      100  0     0 200
      200  0   200 200
      300  0   200   0
      400  200 200   0
      500  100 100 100      
   }
   foreach {i2 r2 g2 b2} $cs {
      if {$i<=$i2} {
         set r [expr round([linear $i1 $r1 $i2 $r2 $i])]
         set g [expr round([linear $i1 $g1 $i2 $g2 $i])]
         set b [expr round([linear $i1 $b1 $i2 $b2 $i])]
         return [format "#%02X%02X%02X" $r $g $b]
      }
      foreach {i1 r1 g1 b1} [list $i2 $r2 $g2 $b2] {}
   } 
}

#  RMax    $r {$e}Flops
proc perf2txt { RMax } {
   foreach {e t} {1e9 Eflops 1e6 Pflops 1e3 Tflops 1 Gflops 1e-3 Mflops 1e-6 Kflops 1e-9 flops} {
      if {$RMax >= $e} {
         set r [expr round($RMax/$e)]
         return "$r$t"
      }
   }
   return ""
}




