# cyberinfra.tcl

#    i  Top500    CI (1, 2, 3  4)
proc ci_level { i } {
   if {$i < 21}  {return 1}
   if {$i < 101} {return 2}
   if {$i < 251} {return 3}
   return 4
}

#  cyberis  cyberisTotalRmax
# CSV-: Cyberinfrastructure.CSV;    CI-$w-$lvls.CSV; 
#            SumRMaxOfCountries.CSV;     SumRMax-RU-Delay.CSV  
proc cyberinfra { } {
   global gtab max_no cyberis cyberisTotalRmax
   log "Cyberinfrastructure"
   openCSV "Cyberinfrastructure" 

   set areas { RnD Unknown Industry Gov.Mil Total }
   set domains {US EU JP CH RU XX}
   set levels {1 2 3 4}
   logCSV "Edition,Level,Usage,US SCs,US Rmax,EU SCs,EU Rmax,JP SCs,JP Rmax,CH SCs, CH Rmax,RU SCs, RU Rmax"

   for {set no 0} {$no <= $max_no} {incr no} {
      foreach l $levels {
         foreach a $areas {
            foreach d $domains {
               set cyberis($no,$l,$a,$d,SCs) 0   
               set cyberis($no,$l,$a,$d,RMax) 0.0   
            }
         }
      }
      
      for {set i 1} {$i <= 500} {incr i} {
         set l [ci_level $i]
         set a $gtab($no,$i,Usage)
         set d $gtab($no,$i,Domain)
         set r [expr double($gtab($no,$i,RMax))]
         set cyberis($no,$l,$a,$d,SCs) [expr $cyberis($no,$l,$a,$d,SCs) + 1]  
         set cyberis($no,$l,$a,$d,RMax) [expr $cyberis($no,$l,$a,$d,RMax) + $r]
         set a Total      
         set cyberis($no,$l,$a,$d,SCs) [expr $cyberis($no,$l,$a,$d,SCs) + 1]  
         set cyberis($no,$l,$a,$d,RMax) [expr $cyberis($no,$l,$a,$d,RMax) + $r]
      }

      set ed [no2edExcel $no]
      foreach l $levels {
         foreach a $areas {
            foreach d $domains {
               set k$d  $cyberis($no,$l,$a,$d,SCs)   
               set r$d $cyberis($no,$l,$a,$d,RMax)   
            }
            logCSV "$ed,$l,$a,$kUS,$rUS,$kEU,$rEU,$kJP,$rJP,$kCH,$rCH,$kRU,$rRU"  
         }
      }
   }
   closeCSV
   
   foreach lvls {{1} {2} {3} {4} {1 2 3 4}} {
      foreach {w x0} {SCs 0 RMax 0.0} {
         log "   .   $w, levels=$lvls"
         openCSV "CI-$w-$lvls"
         logCSV "   .   $w, levels=$lvls"
         logCSV "Edition,RnD,Unknown,Industry,Gov.Mil"
         for {set no 0} {$no <= $max_no} {incr no} {
            logCSV ""
            logCSV0 "[no2edExcel $no]"
            foreach a {RnD Unknown Industry Gov.Mil} {
               set x $x0
               foreach l $lvls {
                  foreach d $domains {
                     set x [expr $x + $cyberis($no,$l,$a,$d,$w)]
                  }
               }
               logCSV0 ",$x"
            }
         }
         logCSV ""
         closeCSV
      }
   }
   
   log "    (Linpack)"
   openCSV "SumRMaxOfCountries"
   logCSV "Edition,US,EU,JP,CH,RU,XX\n"
   for {set no 0} {$no <= $max_no} {incr no} {
      logCSV0 "[no2edExcel $no]"
      foreach d $domains {
         set s 0.0
         foreach l $levels {
            set s [expr $s + $cyberis($no,$l,Total,$d,RMax)]
         }
         set cyberisTotalRmax($no,$d) $s
         logCSV0 ",$s"
      }
      logCSV ""
   }  
   closeCSV

   log "        (Linpack)"
   openCSV "SumRMax-RU-Delay"
   logCSV "        (Linpack)"
   logCSV "Edition,US,EU,JP,CH\n"
   for {set no 0} {$no <= $max_no} {incr no} {
      logCSV0 "[no2edExcel $no]"
      set x $cyberisTotalRmax($no,RU)
      foreach d {US EU JP CH} {
         if {$x == 0} {
            logCSV0 ","
            continue
         }
         for {set n $no} {$n >= 0} {set n [expr $n-1]} {
            if {$x >= $cyberisTotalRmax($n,$d)} {
               break
            }
         }
         logCSV0 ",[expr double($no - $n) / 2]"        
      }
      logCSV ""
   }
   closeCSV
}
