# plot2080.tcl

#   : 20%   80% 

#     Y  
proc pc2y { pc } {
   global cH
   set y1 [expr $cH - 40]
   set y2 115
   return [linear 0 $y1 100 $y2 $pc]
}

#  i=0..500   X  
proc i2x { i } {
   global cW
   set x1 75
   set x2 [expr $cW-20]
   return [linear 0 $x1 500 $x2 $i]
}


#     (pc)
proc hLine2080 { pc } {
   global cF1 cW
   set y [pc2y $pc]
   if {$pc % 10} {
      .plot.c create line 75 $y [i2x 500] $y -dash {2 2}
   } else {
      .plot.c create line 70 $y [i2x 500] $y
      .plot.c create text 65 $y -text "$pc%" -font {Helvetica 18} -anchor e
   }
}

#    (i)
proc vLine2080 { i } {
   global cF1
   set x  [i2x $i]
   set y1 [expr [pc2y 0] + ($i % 20 ? 17 : 5)]
   set y2 [pc2y 100]
   if {$i % 50} {
      .plot.c create text $x [expr $y1 + 2] -text $i -font $cF1 -anchor n
      .plot.c create line $x $y1 $x $y2 -dash ,
   } else {
      .plot.c create text $x [expr $y1 + 2] -text $i -font $cF1 -anchor n
      .plot.c create line $x $y1 $x $y2
   }
}

#  2080:     [.plot.bs.scale get]
proc plot2080 { } {
   global cW cH cF gtab
   set no [.plot.bs.scale get]
   
   #  
   for {set pc 0} {$pc <= 100} {set pc [expr $pc + 2]} {
      hLine2080 $pc
   }
   
   #  
   for {set i 0} {$i <= 500} {set i [expr $i + 10]} {
      vLine2080 $i
   }
   
   #  
   timeScale $no
   
   #  
   set coords {}
   set pc 0.0
   lappend coords [i2x 0] [pc2y 0.0] 
   for {set i 1} {$i <= 500} {incr i} {
      set pc [expr $pc + 100*$gtab($no,$i,pcRMax)]
      lappend coords [i2x $i] [pc2y $pc]
   }
   .plot.c create line $coords -fill red -width 4
   update
   # .plot.c postscript -file "Results2080\\[no2ed $no]-2080.ps"
}