# plotCI.tcl
#  

#    CI-: xc y1 --   
# h0 --  ; $w / $m --     
proc drawLevel { xc y1 w0 m0 h0 RnD Unknown Industry GovMil Total } {
   global cF
   set w [expr double($w0)]
   set m [expr double($m0)]
   set h [expr double($h0)]
   set x0 [expr double($xc) - $w / 2.0]
   set x1 [expr double($xc) - double($Total) * $w / $m / 2.0]
   set x2 [expr double($xc) + double($Total) * $w / $m / 2.0]
   set y2 [expr double($y1) + $h]
   if {$Total > 0} {
      set cvs [list #FF0000 $RnD #FFFF00 $Unknown \
                    #00FF00 $Industry #0000FF $GovMil] 
      set xB $x1
      foreach {c v} $cvs {
         set xE [expr $xB + double($v) * $w / $m]
         .plot.c create rectangle $xB $y1 $xE $y2 -width 0 -fill $c
         set xB $xE
      }   
      .plot.c create rectangle $x1 $y1 $x2 $y2 -width 1 -fill ""
   }
   # .plot.c create text $x0 $y1 -text $Total -font $cF -anchor n
}

#  CI-:     [.plot.bs.scale get]
proc plotCI { } {
   global cW cH cF cyberis gtab
   
   set no [.plot.bs.scale get]
   
   timeScale $no
   #=====================================================================
   #   
   array set yy {H1 115 R1 370 H2 425 R2 680}
   set domains {1 US 2 EU 3 RU 4 CH 5 JP}
   foreach i {1 2 3 4 5} {
      set xc($i) [expr double($cW)*(double($i) - 0.5) / 5]
   }
   set levelH 45
   foreach l {1 2 3 4} {
     set ySCs($l)  [expr $yy(H1) -5 + $l*$levelH]
     set yRMax($l) [expr $yy(H2) -5 + $l*$levelH] 
   }
   set FH {Helvetica 24 bold}
   set wc [expr $cW / 5 - 10]

   #=====================================================================
   set chA $gtab($no,1,Domain)
   foreach {i a} $domains {
      .plot.c create text $xc($i) $yy(H1) -text $a -font $FH -anchor n
      .plot.c create text $xc($i) $yy(H2) -text $a -font $FH -anchor n
      if { $chA eq $a } {
         flagCI $xc($i) $yy(H1)
         flagCI $xc($i) $yy(H2)
      }
   }

   #  RMax
   set m 0.0
   foreach {i a} $domains {
      foreach l {1 2 3 4} {
         set x $cyberis($no,$l,Total,$a,RMax)
         if {$x > $m} {
            set m $x
         }
      }
   }

   foreach {i d} $domains {
      foreach l {1 2 3 4} {
         drawLevel $xc($i) $ySCs($l) $wc 160 $levelH $cyberis($no,$l,RnD,$d,SCs) $cyberis($no,$l,Unknown,$d,SCs) $cyberis($no,$l,Industry,$d,SCs) $cyberis($no,$l,Gov.Mil,$d,SCs) $cyberis($no,$l,Total,$d,SCs)
         drawLevel $xc($i) $yRMax($l) $wc $m $levelH $cyberis($no,$l,RnD,$d,RMax) $cyberis($no,$l,Unknown,$d,RMax) $cyberis($no,$l,Industry,$d,RMax) $cyberis($no,$l,Gov.Mil,$d,RMax) $cyberis($no,$l,Total,$d,RMax)
      }
   }
   
   #    
   set ets  { 1e9  Eflops 1e6  Pflops 1e3 Tflops 1 Gflops 1e-3 Mflops 
              1e-6 Kflops 1e-9 flops}
   set mscs { 1000  {20 20 20 20 20 100 200 200 200 200}
              500   {10 10 10 10 10 50 100 100 100 100}
              100   {2 2 2 2 2 10 20 20 20 20}
              50    {1 1 1 1 1 5 10 10 10 10}
              10    {0.2 0.2 0.2 0.2 0.2 1 2 2 2 2}
              5     {0.1 0.1 0.1 0.1 0.1 0.5 1 1 1 1}
   }
   set mscs { 
      1000 {20 20 20 20 20 100 200 200 200 200}
      800  {16 16 16 16 16 80 160 160 160 160}
      600  {12 12 12 12 12 60 120 120 120 120}
      400  {8 8 8 8 8 40 80 80 80 80}
      200  {4 4 4 4 4 20 40 40 40 40}
      100  {2 2 2 2 2 10 20 20 20 20}
      80   {1.6 1.6 1.6 1.6 1.6 8 16 16 16 16}
      60   {1.2 1.2 1.2 1.2 1.2 6 12 12 12 12}
      40   {0.8 0.8 0.8 0.8 0.8 4 8 8 8 8}
      20   {0.4 0.4 0.4 0.4 0.4 2 4 4 4 4}
      10   {0.2 0.2 0.2 0.2 0.2 1 2 2 2 2}
      8    {0.16 0.16 0.16 0.16 0.16 0.8 1.6 1.6 1.6 1.6}
      6    {0.12 0.12 0.12 0.12 0.12 0.6 1.2 1.2 1.2 1.2}
      4    {0.08 0.08 0.08 0.08 0.08 0.4 0.8 0.8 0.8 0.8}
      2    {0.04 0.04 0.04 0.04 0.04 0.2 0.4 0.4 0.4 0.4}
      1    {0.02 0.02 0.02 0.02 0.02 0.1 0.2 0.2 0.2 0.2}
   }   
   
   foreach {e txt} $ets {
      foreach {k sc} $mscs {
         set x [expr 100 + $e * double($k) * double($wc) / double($m) ]
         # debug "0 m=$m wc=$wc k=$k e=$e x=$x cw=$cW txt=$txt"
         if {$x <= $cW} {
            break
         }
      }
      if {$x <= $cW} {
         break
      }
   }
   # debug "1 m=$m wc=$wc k=$k e=$e x=$x cw=$cW txt=$txt sc=$sc"
   # drawRule x y w m vs e txt --    x y
   drawRule 20 $yy(R1) $wc 160 {10 10 10 10 10 50 100 100 100 100} 1 ""
   drawRule 20 $yy(R2) $wc $m $sc $e $txt
   
   update
   # .plot.c postscript -file "Results\\CI-[no2ed $no].ps"
}

#  
proc flagCI { x y } {
   global myImages
   .plot.c create image [expr $x + 40] [expr $y + 10] -image $myImages(flag)
}

#   
proc drawRule { x0 y0 w0 m0 vs e txt} {
   global cF
   set w [expr double($w0)]
   set m [expr double($m0)]
   set y1 [expr double($y0)]
   set y2 [expr $y1 + 8.0]
   set y3 [expr $y1 - 20.0]
   set s 0
   set xB [expr double($x0)]
   .plot.c create text $xB $y3 -text [format "%.1f" $s] -font cF -anchor n
   set c black
   set c1 white
   set i 0
   foreach v $vs {
      incr i
      set xE [expr $xB + $v * $e * $w / $m]
      set s  [expr $s + $v]
      .plot.c create rectangle $xB $y1 $xE $y2 -width 1 -fill $c
      set c2 $c1
      set c1 $c
      set c  $c2
      set xB $xE
      if {$i > 4} {
         .plot.c create text $xB $y3 -text [format "%.1f" $s] -font cF -anchor ne
      }
   }
   .plot.c create text [expr $xB + 5.0] $y3 -text $txt -font cF -anchor nw
}

