# plotPstrsAn.tcl
#      

global ValCols cntrs gmtrs

array set ValCols {
    STRAT { Top1-5      #74962c 
            Top5-10     #ac2728 
            Top10-20    #0099c3
            Top20-100   #e1a308
            Top100-250  #cf116b
            Top250-500  #000000
          } 
    CHIP  { Alpha       #d9d9db 
            IBM         #4f7aa7 
            HP          #878a88
            Intel       #7a4d83
            MIPS        #ba3d39
            SPARC       #d39d44
            AMD         #699d56
            Proprietary #4b5a6a
          } 
    MNFCTR  {
						Cray       #db843d 
						IBM        #4198af
						HP         #89a54e 
						Other      #71588f
          }
    IC    { 
            Infiniband #0000FF
            Ethernet   #8a8a8a 
            Myrinet    #d000d0
            Custom     #FF0000
            Quadrics   #00FF00
            SCI        #6600cc
          }
    Usage { Gov.Mil    #0000FF 
						Industry   #00FF00  
						Unknown    #FFFF00 
						RnD        #FF0000 
          }
    SEGMENT {
            Government #0000FF
            Vendor     #008080
            Industry   #00FF00 
            Classified #FFFF00
            Research   #FF0000
            Academic   #C000C0            
          }          
}

# 					SGI        #E91657
#						Bull       #ff6600 
#						Fujitsu    #37c85f 
#						Appro      #6666FF
#						Dell       #00ff99
#						Hitachi    #0099b2
#						Sun        #606060

array set gmtrs {
    CHIP    { pLx 10   pLy 130   pLw 150   pLh 40    pLd 0 
              f  {Helvetica 18 bold} fc1 #FFFFFF fc2 #000000
            } 
    Usage   { pLx 10   pLy 130   pLw 150   pLh 40    pLd 0 
              f  {Helvetica 18 bold} fc1 #FFFFFF fc2 #000000
            } 
    SEGMENT { pLx 10   pLy 130   pLw 150   pLh 40    pLd 0 
              f  {Helvetica 18 bold} fc1 #FFFFFF fc2 #000000
            }
    MNFCTR  { pLx 10   pLy 130   pLw 150   pLh 40    pLd 0 
              f  {Helvetica 18 bold} fc1 #FFFFFF fc2 #000000
            }
    IC      { pLx 10   pLy 130   pLw 150   pLh 40    pLd 0 
              f  {Helvetica 18 bold} fc1 #FFFFFF fc2 #000000
            }
    STRAT   { pLx 10   pLy 130   pLw 150   pLh 40    pLd 0 
              f  {Helvetica 18 bold} fc1 #FFFFFF fc2 #000000
            }
}

set cntrs { Top1-10 Top11-20 Top21-100 Top101-250 Top251-500 Top1-500 }

# e     plotDB(c,no,v,cntr,t)
# c    <- { IC CHIP MNFCTR SEG Usage } --    
# no   <- [0..max_no] --  Top500
# v    --      $c (. ValCols)  Total
# cntr <- { Top1-10 Top11-20 Top21-100 Top101-250 Top251-500 Top1-500 }
# t    <- { SCs RMax }

proc plotPosterUsageSCs    { } { plotPosterDB Usage SCs  }
proc plotPosterUsageRMax   { } { plotPosterDB Usage RMax }
proc plotAnimeUsage        { } { plotAnimeDB  Usage }
proc plotPosterSegmentSCs  { } { plotPosterDB SEGMENT SCs  }
proc plotPosterSegmentRMax { } { plotPosterDB SEGMENT RMax }
proc plotAnimeSegment      { } { plotAnimeDB  SEGMENT }
proc plotPosterMnfctrSCs   { } { plotPosterDB MNFCTR SCs  }
proc plotPosterMnfctrRMax  { } { plotPosterDB MNFCTR RMax }
proc plotAnimeMnfctr       { } { plotAnimeDB  MNFCTR }
proc plotPosterIcSCs       { } { plotPosterDB IC SCs  }
proc plotPosterIcRMax      { } { plotPosterDB IC RMax }
proc plotAnimeIc           { } { plotAnimeDB  IC }
proc plotPosterChipSCs     { } { plotPosterDB CHIP SCs  }
proc plotPosterChipRMax    { } { plotPosterDB CHIP RMax }
proc plotAnimeChip         { } { plotAnimeDB  CHIP }

proc plotPosterStrat       { } {
   global plotDB max_no gtab

   #  --  
   # plotDB(STRAT,$no,  v  ,Top1-500,RMax)
   # plotDB(STRAT,$no,Total,Top1-500,RMax)

   for {set no 0} {$no <= $max_no} {incr no} {
  	  set r0 [expr double($gtab($no,1,RMax))]
      set r1 $r0
      foreach { v i } {Top1-5 5 Top5-10 10 Top10-20 20 \
                       Top20-100 100 Top100-250 250} {
         set r2 [expr double($gtab($no,$i,RMax))]
         set plotDB(STRAT,$no,$v,Top1-500,RMax) [expr $r1 - $r2]
         set r1 $r2
      }
      set plotDB(STRAT,$no,Top250-500,Top1-500,RMax) [expr $r1]
      set plotDB(STRAT,$no,Total,Top1-500,RMax) $r0
   }
   #  
   plotPosterDB STRAT RMax
}

proc plotAnimeDB { c } {
   global plotDB max_no ValCols cntrs gmtrs
   global cW cH

   set cF  {Helvetica 18}
   set cF1 {Helvetica 12 bold}
   
   #   
   collectPltoDB
   
   set no [.plot.bs.scale get]

   #  
   timeScale $no

   #   { val1 color1 ... }
   set vcs $ValCols($c)

   #  
   mapLegend $gmtrs($c) $vcs ""
   
   #     {left center right}
   set cntrTypeB1B2B3 { 
       Top1-10    RMax  1  3  5
       Top11-20   RMax  6  8 10
       Top21-100  RMax 11 13 15
       Top101-250 RMax 16 18 20
       Top251-500 RMax 21 23 25
       Top1-500   RMax 29 31 33
       Top1-500   SCs  35 37 39
   }   

   #    
   array set g $gmtrs($c)
   
   set vx1 1
   set vx2 39
   set x1  [expr $g(pLx) + $g(pLw) + 80 ]
   set x2  [expr $cW - 10 ]

   set vy1 100
   set vy2 0
   set y1  [expr 170]
   set y2  [expr $cH - 15 ]
   set gxy [list vx1 $vx1 vx2 $vx2 vy1 $vy1 vy2 $vy2 x1 $x1 x2 $x2 y1 $y1 y2 $y2]
      
   foreach { cntr t b1 b2 b3 } $cntrTypeB1B2B3 {
     #    
     # : (plotDB($c,$no,$v,$cntr,$t) / plotDB($c,$no,Total,$cntr,$t))*100
     #   no v
     set a1 [v2x $b1 $gxy]
     set a2 [v2x $b3 $gxy]
     set pc1 100
     set total $plotDB($c,$no,Total,$cntr,$t)
     foreach { v color } $vcs {
        set pc2 [expr $pc1 - ($plotDB($c,$no,$v,$cntr,$t)/$total)*100 ]
        .plot.c create rectangle $a1 [v2y $pc1 $gxy] $a2 [v2y $pc2 $gxy] \
                       -fill $color -outline {}
        set pc1 $pc2
     }
   }  
   
   #      +    
   for { set pc 0 } { $pc <= 100 } { set pc [expr $pc + 2] } {
      set y [v2y $pc $gxy]
      if { $pc % 10 } {
         .plot.c create line $x1 $y $x2 $y -fill #FFFFFF -dash {. } 
      } else {
         .plot.c create line $x1 $y $x2 $y -fill #FFFFFF -width 1
         .plot.c create line $x1 $y [expr $x1 - 5] $y -fill #000000 -width 2
         .plot.c create text [expr $x1 - 10] $y -text "$pc%" \
                             -anchor e -font $cF
      }
   }

   foreach { cntr t b1 b2 b3 } $cntrTypeB1B2B3 {
      #  
      set a1 [v2x $b1 $gxy]
      set a2 [v2x $b2 $gxy]
      set a3 [v2x $b3 $gxy]
      .plot.c create rectangle $a1 $y1 $a3 $y2 -fill {} -outline #000000 -width 2
      #   
      set c1 [expr $y1 - 5]
      set c2 [expr $y1 - 7]
      set c3 [expr $y1 - 30]
      .plot.c create line $a2 $y1 $a2 $c1 -fill #000000 -width 2
      .plot.c create text $a2 $c2 -text $cntr    -anchor s -font $cF
      .plot.c create text $a2 $c3 -text "$t (%)" -anchor s -font $cF
   }
   update
   # .plot.c postscript -file "Results\\Anime-$c-[no2ed $no].ps"
}

proc plotAnimeStrat       { } {
   global max_no gtab
   global cW cH

   set cF  {Helvetica 18}
   set cF1 {Helvetica 12 bold}
   
   set no [.plot.bs.scale get]

   #  
   timeScale $no

   #    
   set vx1 -0.5
   set vx2 500.5
   set x1  [expr 80 ]
   set x2  [expr $cW - 10 ]

   set vy1 100
   set vy2 0
   set y1  [expr 120]
   set y2  [expr $cH - 50 ]
   set gxy [list vx1 $vx1 vx2 $vx2 vy1 $vy1 vy2 $vy2 x1 $x1 x2 $x2 y1 $y1 y2 $y2]
   
   #    
   set t [expr double($gtab($no,1,RMax))]
   for { set i 1 } { $i <= 500 } { incr i } {
      set pc [expr (double($gtab($no,$i,RMax))/$t)*100.0 ]
      set b1 [v2y $pc $gxy]
      set a1 [v2x [expr $i - 0.5] $gxy]
      set a2 [v2x [expr $i + 0.5] $gxy]
      if { $i % 10 } {
         .plot.c create rectangle $a1 $b1 $a2 $y2 -fill #000000 -outline {}
      } else {
         .plot.c create rectangle $a1 $b1 $a2 $y2 -fill #FF0000 -outline {}
      }
   }
   
   #      +    
   for { set pc 0 } { $pc <= 100 } { set pc [expr $pc + 2] } {
      set y [v2y $pc $gxy]
      if { $pc % 10 } {
         .plot.c create line $x1 $y $x2 $y -fill #FFFFFF -dash {. } 
      } else {
         .plot.c create line $x1 $y $x2 $y -fill #FFFFFF -width 1
         .plot.c create line $x1 $y [expr $x1 - 5] $y -fill #000000 -width 2
         .plot.c create text [expr $x1 - 10] $y -text "$pc%" \
                             -anchor e -font $cF
      }
   }
   
   #      +    
   for { set pc 0 } { $pc <= 100 } { set pc [expr $pc + 2] } {
      set y [v2y $pc $gxy]
      if { $pc % 10 } {
         .plot.c create line $x1 $y $x2 $y -fill #FFFFFF -dash {. } 
      } else {
         .plot.c create line $x1 $y $x2 $y -fill #FFFFFF -width 1
         .plot.c create line $x1 $y [expr $x1 - 5] $y -fill #000000 -width 2
         .plot.c create text [expr $x1 - 10] $y -text "$pc%" \
                             -anchor e -font $cF
      }
   }

   #      
   for { set i 10 } { $i <= 500 } { set i [expr $i + 10] } {
      set a1 [v2x $i $gxy]
      if { $i % 20 } {
         set b1 [expr $y2 + 5]
         set b2 [expr $y2 + 7]
      } else {
         set b1 [expr $y2 + 25]
         set b2 [expr $y2 + 27]
      }
      .plot.c create line $a1 $y2 $a1 $b1 -fill #000000 -width 1
      .plot.c create text $a1 $b2 -text $i -anchor n -font $cF1
   }
   
   #  
   # .plot.c create rectangle $x1 $y1 $x2 $y2 -fill {} -outline #000000 -width 1
   update
   # .plot.c postscript -file "Results\\Anime-Strat-[no2ed $no].ps"
}

proc plotPosterDB { c t } {
   global plotDB max_no ValCols cntrs gmtrs
   global cW cH
   
   set cF  {Helvetica 18}
   set cF1 {Helvetica 11} 
   
   #   
   collectPltoDB
   
   #   { val1 color1 ... }
   set vcs $ValCols($c)

   #  
   mapLegend $gmtrs($c) $vcs $t
   
   #    
   array set g $gmtrs($c)
   set vx1 -0.5
   set x1  [expr $g(pLx) + $g(pLw) + 80 ]
   set vx2 [expr $max_no + 0.5]
   set x2  [expr $cW - 10 ]
   set vy1 100
   set y1  [expr 20]
   set vy2 0
   set y2  [expr $cH - 60 ]
   set gxy [list vx1 $vx1 vx2 $vx2 vy1 $vy1 vy2 $vy2 x1 $x1 x2 $x2 y1 $y1 y2 $y2]
   
   #    
   # : (plotDB($c,no,v,Top1-500,$t) / plotDB($c,no,Total,Top1-500,$t))*100
   #   no  v
   
   for { set no 0 } { $no <= $max_no } { incr no } {
      set a1 [v2x [expr $no - 0.5] $gxy]
      set a2 [v2x [expr $no + 0.5] $gxy]
      set pc1 100
      set total $plotDB($c,$no,Total,Top1-500,$t)
      foreach { v color } $vcs {
         set pc2 [expr $pc1 - ($plotDB($c,$no,$v,Top1-500,$t)/$total)*100 ]
         .plot.c create rectangle $a1 [v2y $pc1 $gxy] $a2 [v2y $pc2 $gxy] -fill \
                        $color -outline {}
         set pc1 $pc2
      }
   }

   #      +    
   for { set pc 0 } { $pc <= 100 } { set pc [expr $pc + 2] } {
      set y [v2y $pc $gxy]
      if { $pc % 10 } {
        .plot.c create line $x1 $y $x2 $y -fill #FFFFFF -dash {. } 
      } else {
        .plot.c create line $x1 $y $x2 $y -fill #FFFFFF -width 1
        .plot.c create line $x1 $y [expr $x1 - 5] $y -fill #000000 -width 2
        .plot.c create text [expr $x1 - 10] $y -text "$pc%" -anchor e -font $cF
      }
   }
   
   #    
   for { set n 0.5 } { $n <= $max_no } { set n [expr $n + 1.0] } {
      set a [v2x $n $gxy]
      .plot.c create line $a $y1 $a $y2 -fill #FFFFFF -width 1
   }

   #    
   for { set n 0 } { $n <= $max_no } { incr n } {
      set a [v2x $n $gxy]
      if { $n % 2} {
         set b1 [expr $y2 + 5]
         set b2 [expr $y2 + 7]
      } else {
         set b1 [expr $y2 + 22]
         set b2 [expr $y2 + 25]
      }
      .plot.c create line $a $y2 $a $b1 -fill #000000 -width 2
      .plot.c create text $a $b2 -text [no2edShort $n] -anchor n -font $cF1
   }

   #    
   .plot.c create rectangle $x1 $y1 $x2 $y2 -fill {} -outline #000000 -width 2

   update
   # .plot.c postscript -file "Results\\Poster-$c-$t.ps"
}

proc v2x { v gxy } {
   array set g $gxy
   return [linear $g(vx1) $g(x1) $g(vx2) $g(x2) $v]
}

proc v2y { v gxy } {
   array set g $gxy
   return [linear $g(vy1) $g(y1) $g(vy2) $g(y2) $v]
}

proc mapLegend { gmtr vcs t } {
   # vcs --   { val1 color1 ... }
   # gmtr --  
   array set g $gmtr

   set x1 $g(pLx)
   set x2 [expr $x1 + $g(pLw)]
   set x0 [expr double($x1 + $x2)/2]
   
   #    
   set y1 $g(pLy)
   set y2 [expr $y1 + $g(pLh)]
   set y0 [expr double($y1 + $y2)/2]
   .plot.c create text $x0 $y0 -text "$t (%)" -fill #000000 -font $g(f)
   set y1 [expr $y2 + $g(pLd)]

   foreach { val color } $vcs {
       set y2 [expr $y1 + $g(pLh)]
       set y0 [expr double($y1 + $y2)/2]
       set x01 [expr $x0 + 1.5]
       set y01 [expr $y0 + 1.5]
       .plot.c create rectangle $x1 $y1 $x2 $y2 -fill $color -outline {} 
       .plot.c create text $x01 $y01 -text $val -fill $g(fc2) -font $g(f)
       .plot.c create text $x0  $y0  -text $val -fill $g(fc1) -font $g(f)
       set y1 [expr $y2 + $g(pLd)]
   }
}

#  plotDB.    ,   
proc collectPltoDB { } {
   global plotDB gtab max_no ValCols cntrs
   
   if [info exist plotDB(Ready)] { return }
   
   log " plotDB..."
   set classes [array names ValCols]
   foreach c $classes {
      if { $c eq "STRAT" } { continue }
      log "      ($c)..."
      #  "  "
      set     vcs $ValCols($c)
      array set v2Cols $vcs
      lappend vcs Total #000000
      
      for {set no 0} { $no <= $max_no } { incr no } {
         #   
         foreach { v  color } $vcs {
            foreach cntr $cntrs {
               foreach t { SCs RMax } {
                  set plotDB($c,$no,$v,$cntr,$t) 0.0
         }  }  }
         
         #    
         for {set i 1} { $i <= 500 } { incr i } {
             set v   {}
             set clr {}
             catch { set v $gtab($no,$i,$c) }
             catch { set clr $v2Cols($v)}
             if { [llength $clr] != 1 } {
                log "Error:    gtab($no,$i,$c)=($v)"
                set v [lindex $vcs 0] 
             }
             foreach cntr [i2cntrs $i] {
                foreach { t d } [list SCs 1.0 RMax $gtab($no,$i,RMax)] {
                   set x [expr $plotDB($c,$no,$v,$cntr,$t) + double($d) ]
                   set plotDB($c,$no,$v,$cntr,$t) $x
                   set x [expr $plotDB($c,$no,Total,$cntr,$t) + double($d) ]
                   set plotDB($c,$no,Total,$cntr,$t) $x             }  }
         }
      }
   } 
   log "  plotDB"
   set plotDB(Ready) 1
}

proc i2cntrs { i } {
   if { $i <= 10  } { return { Top1-10    Top1-500 } }
   if { $i <= 20  } { return { Top11-20   Top1-500 } }
   if { $i <= 100 } { return { Top21-100  Top1-500 } }
   if { $i <= 250 } { return { Top101-250 Top1-500 } }
                      return { Top251-500 Top1-500 }
}

