# readTop500Files.tcl

#   : uname Processors => Cores
proc uname { name } {
   if {$name eq "Processors"} then {return Cores}
   if {$name eq "Rpeak"} then {return RPeak}
   if {$name eq "Rmax"} then {return RMax}
   if {$name eq "TotalCores"} then {return Cores}
   return $name
}

#     global gvals(n) = { v1 v2 ... }
# n --  , v -- .    not_collect  
proc collect_vals { n v } {
   global gvals not_collect
   if {[lsearch -exact $not_collect $n] != (-1)} then {return}
   lappend gvals($n) $v
   set gvals($n) [lsort -unique $gvals($n)]
}

#  CSV-   gnames, gvals  gtab
proc readfile { no } {
   global gnames gtab

set ed [no2ed $no]
set ok 0
# ---  catch
catch {
   set fname "CSV/TOP500_$ed.csv"
   log "[strTime] > $fname"
   set fin [open $fname]
   #  
   set names [split [regsub -all " " [gets $fin] ""] ","]
   set no_names [llength $names]
   # log $names
   foreach name $names {
      lappend gnames([uname $name]) $no 
   }

   set i 1
   while {[gets $fin line] >= 0} {
      #   $i
      set vals [split $line ","]
      if {[llength $vals] != $no_names} then {
         log "  $i  $no_names "}
      foreach name $names {
         set n [uname $name]
         set v [lindex $vals 0]
         set vals [lrange $vals 1 end]
         set gtab($no,$i,$n) $v
         collect_vals $n $v
      } 
      incr i
   }
   log0 " $i"
   close $fin
set ok 1
}  rc
# ---  catch
   if {$ok} {
      # 
      log0 " - O\'K"
   } else {
      # 
      log [mkErrorCode "   \"$fname\"."]
   }
   catch {close $fin}
   return
}

