# setConstants.tcl

global fout max_ed max_trend_ed max_no max_trend_no gnames gtab gvals not_collect
global sumRMax doms ApplicationAreas Segments Usages cyberis minP maxP
global ruSCs outCSV calcfields

set logFile      "top500-log.txt"
set fout         [open $logFile w]
set minP 1e-1
set maxP 1e10
set max_no       [ed2no $max_ed]
set max_trend_no [ed2no $max_trend_ed]
set calcfields   {Domain CpT Usage logRMax pcRMax SEGMENT MNFCTR IC CHIP}

set not_collect { RMax Proc.Frequency Nhalf RPeak Rank Cores Nmax 
                  Power Site PreviousRank AcceleratorCores Year 
                  ProcessorCores Effeciency(%) FirstAppearance
                  Name MeasuredSize CoresperSocket FirstRank
                  Mflops/Watt 
                }

array set doms {
      {United States} US Austria EU Belgium EU Bulgaria EU Cyprus EU
      {Czech Republic} EU Denmark EU Finland EU France EU Germany EU Greece EU 
      Hungary EU Ireland EU Italy EU Liechtenstein EU Luxembourg EU 
      Netherlands EU Norway EU Poland EU Portugal EU Slovenia EU Spain EU
      Sweden EU Switzerland EU Turkey EU {United Kingdom} EU
      {Slovak Republic} EU
      China CH Japan JP Russia RU Belarus RU
      Australia XX Brazil XX Canada XX Colombia XX
      Egypt XX {Hong Kong} XX India XX Indonesia XX Israel XX {Korea; South} XX 
      Malaysia XX Mexico XX {New Zealand} XX Nigeria XX Oman XX Peru XX
      Philippines XX {Puerto Rico} XX Qatar XX 
      {Saudia Arabia} XX {Saudi Arabia} XX Singapore XX
      {South Africa} XX Taiwan XX Thailand XX {United Arab Emirates} XX
      Venezuela XX Vietnam XX
   } 

array set Segments {
   {}         Unknown 
   Academic   RnD
   Classified Unknown
   Government Gov.Mil
   Industry   Industry
   Others     Unknown
   Research   RnD
   Vendor     Unknown
}

array set Usages { RnD 0   Unknown 1   Industry 2   Gov.Mil 3 }   

array set ApplicationAreas {
   {}                 Unknown
   AFIS               Unknown
   Aerospace          Industry 
   Automotive         Industry
   Benchmarking       Unknown
   Biochemistry       Industry
   Biology            Industry
   CFD                Industry
   Chemistry          Industry
   Chess              Unknown
   Construction       Industry
   Consulting         Industry
   Database           Industry
   Defense            Gov.Mil
   {Digital Content Creation} Industry
   {Digital Media}    Industry
   Economics          Industry
   Electronics        Industry
   Energy             Industry
   Entertainment      Industry
   Environment        Industry
   Finance            Industry
   Gaming             Industry
   Geophysics         Industry
   Hardware           Industry
   {Heavy Industry}   Industry
   {Image Proc./Rendering} Industry
   {Information Processing Service} Industry
   {Information Service} Industry
   {Internet Provider} Industry
   {Life Science}     RnD
   {Logistic Services} Industry
   Manufacturing      Industry
   Mechanics          Industry
   Media              Industry
   Medicine           Industry
   {Not Specified}    Unknown
   Pharmaceutics      Industry
   Research           RnD
   Retail             Unknown
   Semiconductor      Industry
   Service            Industry
   Software           Industry
   Telecomm           Industry
   Transportation     Industry
   WWW                Industry
   {Weather Forecasting} Industry
   {Weather and Climate Research} RnD
}

