#!/usr/bin/wish\
exec wish "$0" "$@"

package require Tk
package require img::png 

# ======================================
global fout max_ed max_trend_ed max_no max_trend_no gnames gtab gvals not_collect
global sumRMax doms ApplicationAreas Segments Usages cyberis minP maxP
global ruSCs outCSV calcfields plotDB

set max_ed       201211
set max_trend_ed 202106

#===============================================================================
# 
proc debug { str } {
   message info "DEBUG $str"
}

proc fatalrror { s rc } {
   tk_messageBox -icon error -type ok -message \
            "$s\nError: [mkErrorCode $rc]\
            \n\n    ."
   exit
}

proc mkErrorCode { rc {delim "\n"}} {
   global errorCode
   set x $errorCode
   set t [lindex $x 0]
   switch $t {
      ARITH       -
      CHILDKILLED -
      CHILDSUSP   - 
      POSIX       { return "[lindex $x end]$delim$rc" }
      default     { return $rc }
}  }

proc loadModule { fname } {
   global myModules
   if [info exists myModules($fname)] {
      debug " \"$fname\"  "
      return
   }
   set ok 0
   catch {
      source $fname
      set myModules($fname) 1
      set ok 1
   } rc
   if { ! $ok } {
      fatalrror "     \"$fname\"" $rc
   }
   return
}

proc loadImage {name fname} {
   global myImages
   if [info exists myImages($name)] {
      return
   }
   set ok 0
   catch {
      set myImages($name) [image create photo -file $fname]
      set ok 1
   } rc
   if { ! $ok } {
      fatalrror "     \"$fname\"" $rc
   }
   return
}

#===========================================================
loadImage flag img/flag.png

loadModule converters.tcl
loadModule setConstants.tcl
loadModule ioUtils.tcl
loadModule readTop500Files.tcl
loadModule calcFields.tcl
loadModule mkCSVfiles.tcl
loadModule cyberinfra.tcl
loadModule SCsInRussia.tcl
loadModule trendsTop500.tcl
loadModule utils.tcl
loadModule plotTrends.tcl
loadModule plotCI.tcl
loadModule plot2080.tcl
# loadModule plotStrat.tcl
loadModule plotPstrsAn.tcl
loadModule plot.tcl

# ===========================================================================

# ===========================================================================
# 

catch {destroy .mw}
labelframe .mw -text "  Top500" -font {Helvetica 12}
pack  .mw
text .mw.text -font {Helvetica 12 bold} -relief sunken -bd 2 \
     -yscrollcommand ".mw.scroll set" -setgrid 1 \
     -width 100 -height 35 -undo 1 -autosep 1
scrollbar .mw.scroll -command ".mw.text yview"
pack .mw.scroll -side right -fill y
pack .mw.text -expand yes -fill both
focus -force .mw.text
update

log "[strTime] : Let us go...\n"

#   
for {set no 0} {$no <= $max_no} {incr no} {
   readfile $no
}

log ""

#         gtab($no,$i,$n)
# $no  0  $max_no, $i  1  500, $n --  

#  :  :
calculations

#  :      10  
# (20  Top500)  80%    10 

set nset [interval [expr $max_no - 20] $max_no]
trend  $nset [interval 1 500]
trend2 $nset 0.80

#  :   
SCsInRussia

#  : 
cyberinfra

#  :  PlotDB
collectPltoDB

#   CSV- ======================================

#    
# top500fields
# top500fieldValues

#   
# analize1 Cores
# analize1 Proc.Frequency
# analize1 CpT

#     -
# rudelay

# "" : stratification.csv
stratificationCSV

#       Top10
analizeTop10

#     
trendfunc

#     
# levelBndrs [interval [expr $max_no+1]  [expr $max_no+30]]

#       Top500
# tops {100} {201011 201106 201111 201206 201211}

#     =================================================
plots

log "[strTime] : The End!"

close $fout
